var LANDSCAPE_LAYOUT = 1;
var PORTRAIT_LAYOUT = 2;
var DEF_SLIDE_WIDTH_HEIGHT_RATIO = 4 /3;
var currLayout = 0;

var wsApp;

function changeLayout(value)
{
  if (currLayout != value)
  {
    currLayout = value;
    if (window.WebShow)
    {
      wsApp = WebShow.app;
      if (wsApp)
        prepareAutoZoom(wsApp);
    }
    // change class of body element
    var bodyElem = document.body;
    try
    {
      if (currLayout == LANDSCAPE_LAYOUT)
      {
        Element.addClassName(bodyElem, 'LandscapeLayout');
        Element.removeClassName(bodyElem, 'PortraitLayout');
      }
      else
      {
        Element.addClassName(bodyElem, 'PortraitLayout');
        Element.removeClassName(bodyElem, 'LandscapeLayout');
      }
    }
    catch(e)
    {
    }
  }
}

var predefinedWidthHeightRatio;
function updateLayout()
{
  var predefinedRatio = predefinedWidthHeightRatio;  //getSlideStageRatio();
  //if (wsApp)
  {
    var w = getViewPortWidth();
    var h = getViewPortHeight();
    var r = w / h;
    if (r >= predefinedRatio)  // width excess
      changeLayout(LANDSCAPE_LAYOUT);
    else  // height excess
      changeLayout(PORTRAIT_LAYOUT);
  }
}

function getSlideStageRatio()  // width / height of #wsStage
{
  try
  {
    var elem = document.getElementById('wsStage');
    var d = Element.getDimensions(elem);
    return d.width / d.height;
  }
  catch(e)
  {
    return DEF_SLIDE_WIDTH_HEIGHT_RATIO;
  }
}

function getViewPortWidth()
{
  return window.innerWidth || document.documentElement.clientWidth;
}
function getViewPortHeight()
{
	return window.innerHeight || document.documentElement.clientHeight;
}

function prepareAutoZoom(wsApp)
{
  wsApp.setAutoZoomerUsePredefinedRatio(true);
  wsApp.setAutoZoomWidthRatio(1);
  wsApp.setAutoZoomHeightRatio(1);
  if (currLayout == PORTRAIT_LAYOUT)
  {
    wsApp.setFixedSpaceWidth(20);
    wsApp.setFixedSpaceHeight(80);
  }
  else
  {
    wsApp.setFixedSpaceWidth(90);
    wsApp.setFixedSpaceHeight(20);
  }
}

// --- playerZone -----------------------------------
function showPlayerZone()
{
  var oldStyle = document.getElementById('wsPlayer').style.display;
	if (oldStyle && (oldStyle.toLowerCase() == 'none'))
	  document.getElementById('wsPlayer').style.display = 'block';
}

function hidePlayerZone()
{
	document.getElementById('wsPlayer').style.display = 'none';
}

// --- General Side Pages ---------------------------
/*
function isLargeWindow()
{
  var w = parseInt(getViewPortWidth());
  return w > 768;
}
*/
function getMaxSidePageWidthPx()
{
  /*if (isLargeWindow())
    return '300px';
  else*/
    return parseInt(getViewPortWidth()) + 'px'
}
function getSidePageFullWidth()
{
  /*
  if (isLargeWindow())
    return '300px';
  else*/
    return '100%';
}
function getSidePageNullWidth()
{
  /*
  if (isLargeWindow())
    return '0px';
  else*/
    return '0%';
}

function initSidePages()
{
  try
  {
    var w = getMaxSidePageWidthPx();
    var elems = Element.select(document.body, '.SidePageContent');
    for (var i = 0, l = elems.length; i < l; ++i)
    {
      var elem = elems[i];
      elem.style.minWidth = w;
    }
  }
  catch(e)
  {
  }
}
function reactViewPortResize()
{
  //initSidePages();
  if (!reactViewPortResize._onResizing)
  {
    reactViewPortResize._onResizing = true;
    updateLayout();
    reactViewPortResize._onResizing = false;
  }
}
reactViewPortResize._onResizing = false;

function showSidePage(elem, callback)
{
  initSidePages();
  var afterFinishFunc = function()
      {
        hidePlayerZone();
        if (callback)
          callback();
      }
  elem.style.display = 'block';
  try
  {
    new Effect.Morph(elem, 
			{duration: 0.5, style: {width: getSidePageFullWidth()},
			 afterFinish: afterFinishFunc});
  }
  catch(e)
  {
    elem.style.width = getSidePageFullWidth();
		afterFinishFunc();
  }
}

function hideSidePage(elem, callback)
{
  try
  {
    var afterFinishFunc = function()
      {
        elem.style.display = 'none';
        if (callback)
          callback();
      }
    new Effect.Morph(elem, {duration: 0.5, style: {width: getSidePageNullWidth()}, afterFinish: afterFinishFunc});
  }
  catch(e)
  {
    elem.style.width = getSidePageNullWidth();
    elem.style.display = 'none';
  }
	showPlayerZone();
}

// --- SlideDir -------------------------------------

function reactSlideDirClick(e)
{
	try
	{
	  var elem = Event.findElement(e, 'li');
		if (elem)  // clicked a dir item
		  hideSlideList();
	}
	catch(e)
	{}
}

function reactBtnSlideListClick(e)
{
  toggleSlideList();
  try { Event.stop(e); } catch(e){};
  return false;
}

function reactSlideListCloserClick(e)
{
	hideSlideList();
  try { Event.stop(e); } catch(e){};
  return false;
}

var slideListVisible = false;

function showSlideList()
{
  showSidePage(document.getElementById('listZone'), showListZoneDone);
  slideListVisible = true;
  //wsApp.setFixedSpaceWidth(260);
}
function showListZoneDone()
{
  showSlideListTitlebar();
  //hidePlayerZone();
}
function showSlideListTitlebar()
{
  var elem = document.getElementById('slideListTitlebar');
  elem.style.display = 'block';
}

function hideSlideList()
{
	hideSlideListTitlebar();
	hideSidePage(document.getElementById('listZone'));
  slideListVisible = false;
  //wsApp.setFixedSpaceWidth(110);
}
function hideSlideListTitlebar()
{
  var elem = document.getElementById('slideListTitlebar');
  elem.style.display = 'none';
}

function toggleSlideList()
{
  if (slideListVisible)
    hideSlideList();
  else
    showSlideList();
}

// --- PresentationInfo -------------------------------------
function reactBtnInfoPageClick(e)
{
  toggleInfoPage();
  try { Event.stop(e); } catch(e){};
  return false;
}
function reactInfoPageCloserClick(e)
{
	hideInfoPage();
  try { Event.stop(e); } catch(e){};
  return false;
}

var infoPageVisible = false;

function showInfoPage()
{
  showSidePage(document.getElementById('infoZone'), showInfoPageDone);
  infoPageVisible = true;
}
function showInfoPageDone()
{
  showInfoPageTitlebar();
}
function showInfoPageTitlebar()
{
  var elem = document.getElementById('infoPageTitlebar');
  elem.style.display = 'block';
}
function hideInfoPageTitlebar()
{
  var elem = document.getElementById('infoPageTitlebar');
  elem.style.display = 'none';
}

function hideInfoPage()
{
	hideInfoPageTitlebar();
	hideSidePage(document.getElementById('infoZone'));
  infoPageVisible = false;
}


function toggleInfoPage()
{
  if (infoPageVisible)
    hideInfoPage();
  else
    showInfoPage();
}

function getInfoTableElem()
{
  return document.getElementById('infoTableBody');
}

function clearTableRows(root)
{
  var rows = root.getElementsByTagName('tr');
  for (var i = rows.length - 1; i >= 0; --i)
    rows[i].parentNode.removeChild(rows[i]);
}

function addInfoRow(key, value)
{
  var root = getInfoTableElem();
  var row = document.createElement('tr');
  // key
  var cell = document.createElement('td');
  cell.className = 'KeyCell';
  var cellText = document.createTextNode(key);
  cell.appendChild(cellText);
  row.appendChild(cell);
  // value
  var cell = document.createElement('td');
  cell.className = 'ValueCell';
  var cellText = document.createTextNode(value);
  cell.appendChild(cellText);
  row.appendChild(cell);
  root.appendChild(row);
}

function fillAppInfo(wsApp)
{
  clearTableRows(getInfoTableElem());
  var metas = wsApp.getMetaData();
  var keys = metas.getKeys();
  var value;
  for (var i = 0, l = keys.length; i < l; ++i)
  {
    value = metas.get(keys[i]);
    if (value)
      addInfoRow(keys[i], value);
  }
  // WebShow version info
  try
  {
    addInfoRow('WebShow Version', WebShow.Version);
  }
  catch(e)
  {
    
  }
}

/////////////////////////////////////////

function hideAllSidePages()
{
  hideInfoPage();
  hideSlideList();
}

/////////////////////////////////////////

var logPanelVisible = false;
function showLogPanel()
{
  //if (Element && Element.show)
  try
  {
    Element.show('logPanel');
    Element.addClassName('navLog', 'Checked');
  }
  //else
  catch(e)
  {
    var elem = document.getElementById('logPanel');
    elem.style.display = '';
    elem.className = 'Checked';
  }
  //$('logPanel').style.display = 'inherit';
  //new Effect.Morph('logPanel', {duration: 0.3, style: {height: '200px'}});
  logPanelVisible = true;  
}
function hideLogPanel()
{
  //new Effect.Morph('logPanel', {duration: 0.3, style: {height: '0px'}});
  //if (Element && Element.hide)
  try
  {
    Element.hide('logPanel');
    Element.removeClassName('navLog', 'Checked');
  }
  //else
  catch(e)
  {
    var elem = document.getElementById('logPanel');
    elem.style.display = 'none';
    elem.className = '';
  }
  //$('logPanel').style.display = 'none';
  logPanelVisible = false;
}
function toggleLogPanel()
{
  if (logPanelVisible)
    hideLogPanel();
  else
    showLogPanel();
}

function loggerOnError(message)
{
  showLogPanel();
}

function reactLogCloserClick(e)
{
  hideLogPanel();
  try { Event.stop(e); } catch(e){};
  return false;
}

function reactToggleLogBtnClick(e)
{
  toggleLogPanel();
  try { Event.stop(e); } catch(e){};
  return false;
}

// --- Slidelist scroll -------------------------------------

function addSlideListItem()  /* for debug */
{
  return;
	//var root = document.getElementById('wsSlideDir').getElementsByTagName('ol')[0];
	var root = document.getElementById('listZone');
	//var root = document.getElementById('wsSlideDir');
	for (var i = 0, l = 100; i < l; ++i)
	{
		//var elem = document.createElement('li');
		var elem = document.createElement('div');
		elem.innerHTML = 'AutoSlide ' + i;
		root.appendChild(elem);
	}
}

var defaultStep = 15;
var scrollStepMaxCount = 0;
var scrollStepCount = 0;
var step = defaultStep;
var scrollTimer;
function scrollElementDown(elemId)
{
  scrollStepCount++;
  if (scrollStepMaxCount && (scrollStepCount < scrollStepMaxCount))
  {
    document.getElementById(elemId).scrollTop+=step;
    scrollTimer = setTimeout('scrollElementDown("'+ elemId + '")', 10);
  }
}

function scrollElementUp(elemId)
{
  scrollStepCount++;
  if (scrollStepMaxCount && (scrollStepCount < scrollStepMaxCount))
  {
    document.getElementById(elemId).scrollTop-=step;
    scrollTimer = setTimeout('scrollElementUp("' + elemId + '")', 10);
  }
}
function scrollElementToTop(elemId)
{
  document.getElementById(elemId).scrollTop = 0;
}
function scrollElementToBottom(elemId)
{
  document.getElementById(elemId).scrollTop = document.getElementById(elemId).scrollHeight;
}

function getScrollHeight()
{
	return getViewPortHeight() * 0.8;
}

function scrollSlideListToTop(e)
{
  scrollElementToTop('html'); // in firefox
	scrollElementToTop('body'); // in webkit
}
function scrollSlideListToBottom(e)
{
  scrollElementToBottom('html');
	scrollElementToBottom('body');
}
function scrollPageUp(e)
{
  stopScrollSlideList();
  scrollStepMaxCount = Math.round(getScrollHeight() / step); // 20;
  scrollElementUp('html');
	scrollElementUp('body');
  try { Event.stop(e); } catch(e){};
  return false;
}
function scrollPageDown(e)
{
  stopScrollSlideList();
  scrollStepMaxCount = Math.round(getScrollHeight() / step); //scrollStepMaxCount = 20;
  scrollElementDown('html');
  scrollElementDown('body');
  /*
  var elem = document.getElementById('sidePanelScroller');
  elem.scrollTop += 75;
  */
  try { Event.stop(e); } catch(e){};
  return false;
}
function startScrollUpSlideList(e)
{
  //alert(document.getElementById('sidePanelScroller'));
  stopScrollSlideList();
  scrollElementUp('html');
	scrollElementUp('body');
  try { Event.stop(e); } catch(e){};
  return false;
}
function startScrollDownSlideList(e)
{
  stopScrollSlideList();
  scrollElementDown('html');
	scrollElementDown('body');
  try { Event.stop(e); } catch(e){};
  return false;
}
function stopScrollSlideList(e)
{
  if (scrollTimer)
    clearTimeout(scrollTimer);
  scrollStepCount = 0;
  try { Event.stop(e); } catch(e){};
  return false;
}
function preventHref(e)
{
  try { Event.stop(e); } catch(e){};
  return false;
}

// --- Initial Events -------------------------------------

function reactWsAppLoaded(e)
{  
  if (WebShow.app)
  {
    wsApp = WebShow.app;
    predefinedWidthHeightRatio = getSlideStageRatio();
    updateLayout();
    fillAppInfo(WebShow.app);
    prepareAutoZoom(WebShow.app);
    //WebShow.app.onSlideSwitched = reactWsAppSlideSwitched;
  }
}

/*
function reactWsAppSlideSwitched(app, newSlide, oldSlide)
{
  updateSlideIndex();
}
*/

function init()
{
  initSidePages();
	//hideAllSidePages();
	//showSlideList();
  addSlideListItem();
  window.onresize = reactViewPortResize;
	try  // avoid IE raise exception while designing
	{
		//if (Event && Event.observe)
		{
      Event.observe('logCloser', 'click', reactLogCloserClick);
      //Event.observe('navLog', 'click', reactToggleLogBtnClick);
			Event.observe('navSlideList', 'click', reactBtnSlideListClick);
			Event.observe('navInfo', 'click', reactBtnInfoPageClick);
			Event.observe('slideListCloser', 'click', reactSlideListCloserClick);
			Event.observe('slideListCloserBottom', 'click', reactSlideListCloserClick);
			Event.observe('infoPageCloser', 'click', reactInfoPageCloserClick);
			Event.observe('infoPageCloserBottom', 'click', reactInfoPageCloserClick);
			Event.observe('wsSlideDir', 'click', reactSlideDirClick);
      
      //Event.observe('btnSlideListScrollToTop', 'click', scrollSlideListToTop);
      //Event.observe('btnSlideListScrollToBottom', 'click', scrollSlideListToBottom);
      Event.observe('slideListUpScroller', 'click', scrollPageUp);
      Event.observe('slideListDownScroller', 'click', scrollPageDown);
      /*
      Event.observe('btnSlideListScrollUp', 'click', preventHref);
      Event.observe('btnSlideListScrollUp', 'mouseover', startScrollUpSlideList);
      Event.observe('btnSlideListScrollUp', 'mouseout', stopScrollSlideList);
      Event.observe('btnSlideListScrollDown', 'click', preventHref);
      Event.observe('btnSlideListScrollDown', 'mouseover', startScrollDownSlideList);
      Event.observe('btnSlideListScrollDown', 'mouseout', stopScrollSlideList);
      */
	    /*
	    Event.observe('sidePanelClient', 'mouseover', reactSideMouseOver);
	    Event.observe('sidePanelTabs', 'mouseover', reactSideMouseOver);
	    Event.observe('sidePanel', 'mouseout', reactSideMouseOut);
	    //Event.observe('sidePanelTabs', 'mouseout', reactSideMouseOut);
	    */
	    Event.observe(document.documentElement, WebShow.AppLauncher.APP_LAUNCH_EVENT, reactWsAppLoaded);
      
      //installSlideNavEventHandlers();
		}
  }
  catch(e)
  {
    document.getElementById('logCloser').onclick = reactLogCloserClick;
    //document.getElementById('navLog').onclick = reactToggleLogBtnClick;
		document.getElementById('navSlideList').onclick = reactBtnSlideListClick;
		document.getElementById('navInfo').onclick = reactBtnInfoPageClick;
		document.getElementById('slideListCloser').onclick = reactSlideListCloserClick;
		document.getElementById('slideListCloserBottom').onclick = reactSlideListCloserClick;
		document.getElementById('infoPageCloser').onclick = reactInfoPageCloserClick;
		document.getElementById('infoPageCloserBottom').onclick = reactInfoPageCloserClick;
    
    //document.getElementById('btnSlideListScrollToTop').onclick = scrollSlideListToTop;
    //document.getElementById('btnSlideListScrollToBottom').onclick = scrollSlideListToBottom;
    document.getElementById('slideListUpScroller').onclick = scrollPageUp;
    document.getElementById('slideListDownScroller').onclick = scrollPageDown;
    /*
    document.getElementById('btnSlideListScrollUp').onclick = preventHref;
    document.getElementById('btnSlideListScrollUp').onmouseover = startScrollUpSlideList;
    document.getElementById('btnSlideListScrollUp').onmouseout = stopScrollSlideList;
    document.getElementById('btnSlideListScrollDown').onclick = preventHref;
    document.getElementById('btnSlideListScrollDown').onmouseover = startScrollDownSlideList;
    document.getElementById('btnSlideListScrollDown').onmouseout = stopScrollSlideList;
    */
  }
  try
  {
    if (WebShow.Logger)
    {
      WebShow.Logger.element = document.getElementById('wsLog');
      WebShow.Logger.onError = loggerOnError;
    }
    if (WebShow.app)  // already loaded
      reactWsAppLoaded();
  }
  catch(e) {}
}

//if (Event && Event.observe)
try
{
  Event.observe(document, 'dom:loaded', init);
}
catch(e)
{  
  window.onload = init;
}